<?xml version="1.0"?>

<ruleset name="Custom Rules" xmlns="http://pmd.sourceforge.net/ruleset/2.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
	xsi:schemaLocation="http://pmd.sourceforge.net/ruleset/2.0.0 http://pmd.sourceforge.net/ruleset_2_0_0.xsd">

    <description>
        Ruleset for Java Projects.
    </description>

    <!-- Best Practises -->
    <rule ref="category/java/bestpractices.xml">
    	<exclude name="SystemPrintln"/>
    	<exclude name="UseVarargs"/>
    </rule>

    <!-- Code Style -->
    <rule ref="category/java/codestyle.xml">
    	<exclude name="AtLeastOneConstructor"/>
    	<exclude name="AvoidFinalLocalVariable"/>
    	<exclude name="CallSuperInConstructor"/>
    	<exclude name="LocalVariableCouldBeFinal"/>
    	<exclude name="LongVariable"/>
    	<exclude name="MethodArgumentCouldBeFinal"/>
    	<exclude name="OnlyOneReturn"/>
    	<exclude name="ShortVariable"/>
    	<exclude name="UnnecessaryLocalBeforeReturn"/>
    </rule>
    <rule ref="category/java/codestyle.xml/ClassNamingConventions">
    <properties>
        <property name="utilityClassPattern" value="[A-Z][a-zA-Z]+(Utils?|Helper|Factory|Mapper|Converter)"/>
    </properties>
    </rule>

    <!-- Design -->
    <rule ref="category/java/design.xml/AbstractClassWithoutAnyMethod"/>
    <rule ref="category/java/design.xml/AvoidDeeplyNestedIfStmts"/>
    <rule ref="category/java/design.xml/AvoidRethrowingException"/>
    <rule ref="category/java/design.xml/AvoidThrowingNewInstanceOfSameException"/>
    <rule ref="category/java/design.xml/AvoidThrowingNullPointerException"/>
    <rule ref="category/java/design.xml/AvoidThrowingRawExceptionTypes"/>
    <rule ref="category/java/design.xml/ClassWithOnlyPrivateConstructorsShouldBeFinal"/>
    <rule ref="category/java/design.xml/CollapsibleIfStatements"/>
    <rule ref="category/java/design.xml/CouplingBetweenObjects"/>
    <rule ref="category/java/design.xml/DoNotExtendJavaLangError"/>
    <rule ref="category/java/design.xml/ExceptionAsFlowControl"/>
    <rule ref="category/java/design.xml/ExcessiveImports"/>
    <rule ref="category/java/design.xml/ExcessiveParameterList"/>
    <rule ref="category/java/design.xml/ExcessivePublicCount"/>
    <rule ref="category/java/design.xml/FinalFieldCouldBeStatic"/>
    <rule ref="category/java/design.xml/ImmutableField"/>
    <rule ref="category/java/design.xml/LogicInversion"/>
    <rule ref="category/java/design.xml/SignatureDeclareThrowsException"/>
    <rule ref="category/java/design.xml/SimplifiedTernary"/>
    <rule ref="category/java/design.xml/SimplifyBooleanExpressions"/>
    <rule ref="category/java/design.xml/SimplifyBooleanReturns"/>
    <rule ref="category/java/design.xml/SimplifyConditional"/>
    <rule ref="category/java/design.xml/SwitchDensity"/>
    <rule ref="category/java/design.xml/UselessOverridingMethod"/>
    <rule ref="category/java/design.xml/UseObjectForClearerAPI"/>
    <rule ref="category/java/design.xml/UseUtilityClass"/>

    <!-- Error Prone -->
    <rule ref="category/java/errorprone.xml">
    	<exclude name="DataflowAnomalyAnalysis"/>
    	<exclude name="DoNotTerminateVM"/>
    	<exclude name="SimpleDateFormatNeedsLocale"/>
    </rule>
    
</ruleset>